<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="原料" prop="itemId">
        <el-input v-model="formData.itemId" placeholder="请输入原料" />
      </el-form-item>
      <el-form-item label="数量" prop="count">
        <el-input v-model="formData.count" placeholder="请输入数量" />
      </el-form-item>
      <el-form-item label="明细类别" prop="detailType">
        <el-radio-group v-model="formData.detailType">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.MES_STOCK_WORKSHOP_DETAIL_TYPE)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="领料单" prop="itemRequisitionCode">
        <el-input v-model="formData.itemRequisitionCode" placeholder="请输入领料单" />
      </el-form-item>
      <el-form-item label="领料明细id" prop="itemRequisitionDetailId">
        <el-input v-model="formData.itemRequisitionDetailId" placeholder="请输入领料明细id" />
      </el-form-item>
      <el-form-item label="投料单" prop="feedingRecordCode">
        <el-input v-model="formData.feedingRecordCode" placeholder="请输入投料单" />
      </el-form-item>
      <el-form-item label="投料id" prop="feedingRecordId">
        <el-input v-model="formData.feedingRecordId" placeholder="请输入投料id" />
      </el-form-item>
      <el-form-item label="操作人员" prop="userId">
        <el-input v-model="formData.userId" placeholder="请输入操作人员" />
      </el-form-item>
      <el-form-item label="单据时间" prop="operateTime">
        <el-date-picker
          v-model="formData.operateTime"
          type="date"
          value-format="x"
          placeholder="选择单据时间"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getStrDictOptions, DICT_TYPE } from '@/utils/dict'
import { StockWorkshopDetailApi, StockWorkshopDetailVO } from '@/api/mes/stockworkshop'

/** 车间仓明细 表单 */
defineOptions({ name: 'StockWorkshopDetailForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  itemId: undefined,
  count: undefined,
  detailType: undefined,
  itemRequisitionCode: undefined,
  itemRequisitionDetailId: undefined,
  feedingRecordCode: undefined,
  feedingRecordId: undefined,
  userId: undefined,
  operateTime: undefined,
})
const formRules = reactive({
  itemId: [{ required: true, message: '原料id不能为空', trigger: 'blur' }],
  count: [{ required: true, message: '数量不能为空', trigger: 'blur' }],
  userId: [{ required: true, message: '操作人员不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await StockWorkshopDetailApi.getStockWorkshopDetail(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as StockWorkshopDetailVO
    if (formType.value === 'create') {
      await StockWorkshopDetailApi.createStockWorkshopDetail(data)
      message.success(t('common.createSuccess'))
    } else {
      await StockWorkshopDetailApi.updateStockWorkshopDetail(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    itemId: undefined,
    count: undefined,
    detailType: undefined,
    itemRequisitionCode: undefined,
    itemRequisitionDetailId: undefined,
    feedingRecordCode: undefined,
    feedingRecordId: undefined,
    userId: undefined,
    operateTime: undefined,
  }
  formRef.value?.resetFields()
}
</script>
